#
# Conditional build:
%bcond_without	static		# don't build static version
%bcond_with	bash_history	# build with additional history in /var/log/bash_hist ;)
%bcond_without	tests	# do not perform "make test"

# NOTE: when updating patchleve, do not forget to update 'sources' file!
%define		ver		4.3
%define		patchlevel	30
%define		rel		1
Summary:	GNU Bourne Again Shell (bash)
Summary(fr.UTF-8):	Le shell Bourne Again de GNU
Summary(pl.UTF-8):	Powłoka GNU Bourne Again Shell (bash)
Name:		bash
Version:	%{ver}%{?patchlevel:.%{patchlevel}}
Release:	%{rel}%{?with_bash_history:inv}
License:	GPL
Group:		Applications/Shells
Source0:	http://ftp.gnu.org/gnu/bash/%{name}-%{ver}.tar.gz
# Source0-md5:	81348932d5da294953e15d4814c74dd1
Source1:	%{name}rc
Source2:	%{name}-skel-.bash_logout
Source3:	%{name}-skel-.bash_profile
Source4:	%{name}-skel-.bashrc
Source5:	http://www.mif.pg.gda.pl/homepages/ankry/man-PLD/%{name}-non-english-man-pages.tar.bz2
# Source5-md5:	d2aacf89c4a444c5da648da69afdb01a
Patch0:		%{name}-paths.patch
Patch1:		%{name}-security.patch
Patch2:		%{name}-autoconf.patch
Patch3:		%{name}-info.patch
Patch4:		%{name}-profile.patch
Patch5:		%{name}-requires.patch
Patch6:		%{name}-compat.patch
Patch8:		%{name}-sighup.patch
Patch9:		%{name}-backup_history.patch
Patch10:	%{name}-act_like_sh.patch
Patch11:	%{name}-elinks_cont.patch
Patch12:	%{name}-pl.po-update.patch
%patchset_source -f https://ftp.gnu.org/gnu/bash/bash-4.3-patches/bash43-%03g 1 %{patchlevel}
URL:		http://www.gnu.org/software/bash/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	bison
BuildRequires:	ncurses-devel >= 5.2
BuildRequires:	readline-devel >= 6.3
BuildRequires:	rpmbuild(macros) >= 1.462
BuildRequires:	sed >= 4.0
BuildRequires:	texinfo
%if %{with static}
# Require static library only for static build
BuildRequires:	glibc-static >= 2.2
BuildRequires:	ncurses-static >= 5.2
BuildRequires:	readline-static >= 6.3
%endif
Requires:	readline >= 6.3
Requires:	setup >= 2.4.6-2
Obsoletes:	bash-doc
Obsoletes:	bash2
Obsoletes:	bash2-doc
Obsoletes:	etcskel
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Bash is a GNU project sh-compatible shell or command language
interpreter. Bash (Bourne Again shell) incorporates useful features
from the Korn shell (ksh) and the C shell (csh). Most sh scripts can
be run by bash without modification. Bash offers several improvements
over sh, including command line editing, unlimited size command
history, job control, shell functions and aliases, indexed arrays of
unlimited size and integer arithmetic in any base from two to 64. Bash
is ultimately intended to conform to the IEEE POSIX P1003.2/ISO 9945.2
Shell and Tools standard. Bash is the default shell for Linux
Mandrake. You should install bash because of its popularity and power.
You'll probably end up using it.

%description -l es.UTF-8
Bash es un interpretador de comandos compatible con sh, que ejecuta
comandos leídos de la entrada padrón o de un archivo. Bash también
incorpora características útiles de las shells Korn y C (ksh y csh).
Bash ha sido desarrollado para ser una adición compatible con la
especificación IEEE Posix para shells y herramientas (IEEE Working
Group 1003.2).

%description -l de.UTF-8
Bash ist eine sh-kompatible Shell und Kommandosprache aus dem
GNU-Projekt. Bash (Bourne Again Shell) vereinigt die nützlichen
Features aus der Korn-Shell (ksh) und der C-Shell (csh). Die meisten
sh-Skripte laufen ohne Änderungen auf bash. Bash hat viele
Erweiterungen im Vergleich zur "normalen" sh, wie z.B.
Kommandozeilenbearbeitung, unbeschränkte Größe der command-history,
Job-Kontrolle, Shell-Funktionen und -Aliase, unbegrenzt große
indizierte Arrays und Integer-Arithmetik in einer Basis von 2 bis 64.
Hauptziel von bash ist es, den IEEE POSIX P1003.2/ISO 9945.2 Shell-
und Tools-Standard einzuhalten. Bash ist die Standard-Shell für Linux
Mandrake.

%description -l fr.UTF-8
Bash est un shell (interpréteur de commande) du projet GNU, compatible
avec le shell historique sh. Bash (Bourne Again SHell) comprend de
nombreuses fonctionnalités du Korn SHell (ksh) et du C SHell (csh). La
plupart des scripts sh sont exécutables sans modifications. Bash
comprend nombre d'améliorations par rapport à sh : édition de la ligne
de commande, historique illimité, contrôle des processus
d'arrière-plan, fonctions de shell, alias, tableaux indexés de taille
illimitée et calcul sur des entiers dans n'importe quelle base de 2 à
64. Bash est conforme au standard IEEE POSIX P1003.2/ISO 9945.2 Shell
and Tools. Bash est le shell par défaut de Mandrake. Vous devriez
l'installer du fait de sa puissance et de sa popularité. Vous finirez
probablement par l'utiliser.

%description -l pl.UTF-8
Bash (Bourne Again SHell) jest projektem GNU powłoki kompatybilnej z
sh oraz interpretera języka poleceń. Posiada użyteczne właściwości
powłok Korn (ksh) i C (csh). Większość skryptów sh może być
uruchamiana w bashu bez modyfikacji. Oferuje on kilka ulepszeń w
stosunku do sh, włączając edycję linii poleceń, nieograniczony rozmiar
historii poleceń, funkcje i aliasy, indeksowane tablice
nieograniczonych rozmiarów oraz arytmetykę całkowitoliczbową o
dowolnej podstawie od 2 do 64. W zamierzeniu ostatecznie ma być zgodny
ze standardem IEEE POSIX P1003.2/ISO 9945.2 Shell and Tools.

%description -l pt_BR.UTF-8
Bash é um interpretador de comandos compatível com sh, que executa
comandos lidos da entrada padrão ou de um arquivo. Bash também
incorpora características úteis das shells Korn e C (ksh e csh). Bash
tem sido desenvolvido para ser uma implementação compatível com a
especificação IEEE Posix para shells e ferramentas (IEEE Working Group
1003.2).

%description -l ru.UTF-8
Bash - это sh-совместимый интерпретатор командного языка (shell),
исполняющий команды, поступающие со стандартного ввода или из файла.
Bash включает полезные расширения из интерпретаторов Korn и C shell
(ksh и csh).

Bash разрабатывается как реализация, отвечающая IEEE Posix Shell and
Tools specification (IEEE Working Group 1003.2).

%description -l tr.UTF-8
Bash standart girişten ya da bir dosyadan komut okuyup çalıştıran sh
uyumlu bir komut dili yorumlayıcısıdır. Aynı zamanda Korn ve C
kabuklarının (ksh ve csh) kullanışlı özelliklerini de kapsar. Bash,
IEEE Posix Kabuk ve Araç ayrıntılarına (IEEE Working Group 1003.2)
uyumlu bir uygulama olarak tasarlanmıştır.

%description -l uk.UTF-8
Bash - це sh-сумістний інтерпретатор командної мови (shell),
виконуючий команди зі стандартного вводу або з файла. Bash містить
користні розширення з інтерпретаторів Korn та C shell (ksh та csh).

Bash розроблявся як реалізація, що відповідає IEEE Posix Shell and
Tools specification (IEEE Working Group 1003.2).

%package static
Summary:	Statically linked GNU Bourne Again Shell (bash)
Summary(pl.UTF-8):	Statycznie skonsolidowany GNU Bourne Again Shell (bash)
Group:		Applications/Shells
Requires:	%{name} = %{version}-%{release}

%description static
Bash is a GNU project sh-compatible shell or command language
interpreter. Bash (Bourne Again shell) incorporates useful features
from the Korn shell (ksh) and the C shell (csh). Most sh scripts can
be run by bash without modification. Bash offers several improvements
over sh, including command line editing, unlimited size command
history, job control, shell functions and aliases, indexed arrays of
unlimited size and integer arithmetic in any base from two to 64. Bash
is ultimately intended to conform to the IEEE POSIX P1003.2/ISO 9945.2
Shell and Tools standard. Bash is the default shell for Linux
Mandrake. You should install bash because of its popularity and power.
You'll probably end up using it. This package contains statically
linked version of bash.

%description static -l pl.UTF-8
Bash jest zaawansowaną powłoką, która wykonuje komendy czytane ze
standardowego wejścia (stdin) lub z pliku. Posiada właściwości powłok
Korn i C (ksh i csh). Bash jest również zaimplementowany IEEE Posix
Shell oraz jest zgodny ze specyfikacją - IEEE Working Group 1003.2. W
tym pakiecie jest wersja basha skonsolidowana statycznie.

%prep
%setup -q -n %{name}-%{ver} -a5
# official patches
%{?patchlevel:%patchset_patch 1 %{patchlevel}}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch8 -p1
%{?with_bash_history:%patch9 -p1}
%patch10 -p1
%patch11 -p1
%patch12 -p1

sed -i -e 's#/usr/bin/printf#/bin/printf#g' tests/intl2.sub

%build
cp -f /usr/share/automake/config.* support
%{__autoconf}
for mode in %{?with_static:static} shared; do
%configure \
	--enable-alias \
	--enable-help-builtin \
	--enable-history \
	--enable-job-control \
	--enable-restricted \
	--enable-readline \
	--with-curses \
	--enable-extended-glob \
	--enable-dparen-arithmetic \
	--enable-separate-helpfiles \
	--without-bash-malloc \
	$([ "$mode" = "static" ] && echo "--enable-static-link") \
	--with-installed-readline

%{__make} \
	DEFS="-DHAVE_CONFIG_H -D_GNU_SOURCE"

[ "$mode" = "static" ] && mv -f bash bash.static
done

%{?with_tests:%{__make} tests}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/bin,/etc/skel,%{_datadir}/%{name}}
%{?with_bash_history:install -d $RPM_BUILD_ROOT/var/log/bash_hist}

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

mv -f $RPM_BUILD_ROOT%{_bindir}/bash $RPM_BUILD_ROOT/bin
%{?with_static:install bash.static $RPM_BUILD_ROOT/bin}

install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/bashrc
echo .so bash.1 > $RPM_BUILD_ROOT%{_mandir}/man1/rbash.1

for d in es fr it ja ko nl pl ; do
	install -d $RPM_BUILD_ROOT%{_mandir}/$d/man1
	install man/$d/* $RPM_BUILD_ROOT%{_mandir}/$d/man1
	echo .so bash.1 > $RPM_BUILD_ROOT%{_mandir}/$d/man1/rbash.1
done

ln -sf bash $RPM_BUILD_ROOT/bin/rbash

install %{SOURCE2} $RPM_BUILD_ROOT/etc/skel/.bash_logout
install %{SOURCE3} $RPM_BUILD_ROOT/etc/skel/.bash_profile
install %{SOURCE4} $RPM_BUILD_ROOT/etc/skel/.bashrc
rm -f $RPM_BUILD_ROOT%{_infodir}/dir

# use our bugtracker, upstream will ignore reports from this anyway
rm -f $RPM_BUILD_ROOT%{_bindir}/bashbug

%find_lang %{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p <lua>
%lua_add_etc_shells /bin/bash /bin/rbash
os.execute("/usr/sbin/fix-info-dir -c %{_infodir} >/dev/null 2>&1")

%preun	-p <lua>
if arg[2] == 0 then
	%lua_remove_etc_shells /bin/bash /bin/rbash
end

%postun	-p	/sbin/postshell
-/usr/sbin/fix-info-dir -c %{_infodir}

%post static -p <lua>
%lua_add_etc_shells /bin/bash.static

%preun static -p <lua>
if arg[2] == 0 then
	%lua_remove_etc_shells /bin/bash.static
end

%files -f %{name}.lang
%defattr(644,root,root,755)
%doc CHANGES NEWS README doc/{FAQ,INTRO}

%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/bashrc
%config(noreplace,missingok) %verify(not md5 mtime size) /etc/skel/.bash_logout
%config(noreplace,missingok) %verify(not md5 mtime size) /etc/skel/.bash_profile
%config(noreplace,missingok) %verify(not md5 mtime size) /etc/skel/.bashrc

%attr(755,root,root) /bin/bash
%attr(755,root,root) /bin/rbash

%{?with_bash_history:%attr(1733,root,root) %dir /var/log/bash_hist}
%{_infodir}/bash.info*
%{_mandir}/man1/*
%lang(es) %{_mandir}/es/man1/*
%lang(fr) %{_mandir}/fr/man1/*
%lang(it) %{_mandir}/it/man1/*
%lang(ja) %{_mandir}/ja/man1/*
%lang(ko) %{_mandir}/ko/man1/*
%lang(nl) %{_mandir}/nl/man1/*
%lang(pl) %{_mandir}/pl/man1/*
%dir %{_datadir}/%{name}
%doc %{_datadir}/%{name}/*

%if %{with static}
%files static
%defattr(644,root,root,755)
%attr(755,root,root) /bin/bash.static
%endif
%changelog
* Mon Oct 06 2014 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/bash.git;a=log;h=master

* Mon Oct 06 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 311493e
- up to 4.3.30; another SECURITY bugfix

* Mon Oct 06 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> c7deb17
- up to 4.3.30; another SECURITY bugfix

* Fri Oct 03 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 1cec0d5
- up to 4.3.29; fixes invalid memory access sometimes

* Fri Oct 03 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 09160ea
- up to 4.3.29; fixes invalid memory access sometimes

* Wed Oct 01 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> b7ccc57
- rel 2; upstream reissued patch 028

* Wed Oct 01 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> bd578be
- up to 4.3.28 (which is the same as PLD 4.3.27-1; just now using official patch)

* Sun Sep 28 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 3e12ae6
- up to 4.3.27 (it's effectively the same as our 4.3.26-2)

* Sat Sep 27 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> d6f116f
- rel 2; additional non-upstream hardening (from FC)

* Sat Sep 27 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> efa9dfe
- up to 4.3.26; the same fix as CVE-2014-6271.patch just in official patch

* Sat Sep 27 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> f2f33bf
- up to 4.3.26; the same fix as CVE-2014-6271.patch just in official patch

* Fri Sep 26 2014 Jacek Konieczny <j.konieczny@eggsoft.pl> 46cf417
- Another CVE-2014-6271 fix

* Wed Sep 24 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> f0324dc
- up to 4.3.25; fixes (sometimes remotely exploitable) CVE-2014-6271

* Thu Jun 05 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 322c0ad
- up to 4.3.18

* Sun Apr 20 2014 Elan Ruusamäe <glen@delfi.ee> 37b19da
- note about sources file

* Sun Apr 20 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 2ba9fd6
- md5 for new patches

* Sat Apr 19 2014 Adam Osuchowski <adwol@pld-linux.org> 0237e5f
- s/http/https/ in patchset source (no md5 digests for official patches
  fetched from original source, so at least https for minimal security)

* Sat Apr 19 2014 Adam Osuchowski <adwol@pld-linux.org> 0432822
- up to patchlevel 11 (including broken completion fix)

* Tue Apr 08 2014 Elan Ruusamäe <glen@delfi.ee> 352e613
- use df to fetch sources. again

* Tue Apr 08 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 28d34d3
- add patches

* Mon Apr 07 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 8268d26
- up to 4.3.8

